#ifndef PROXYSCAN_CONF_H
#define PROXYSCAN_CONF_H
/* Pxys - An IRC ProxyScan, conf.h
 * 
 * Copyright (C) 2001,2002 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * 
 * Configuration file reading methods (pxys.conf)
 *
 * $Id: conf.h,v 1.17 2002/07/21 14:50:39 mbuna Exp $
 */


#include "config.h"
#include "typedefs.h"
#include "m_structs.h"

#define PROXYSCAN_CONF_FILENAME     "pxys.conf"

#undef RAND_NICK				/* change to define to enable nickname randomization */
#undef RE_RAND_NICK				/* change to define to enable nickname randimization after a time intetval
						 * NEEDS RAND_NICK to be enabled
						 */

#define AUTO_NICKCHANGE_TIME        7200		/* 2h */
#define PING_DELAY                  37			/* 37 secs */
#define RESYNC_PROXYCACHE_DELAY     3600		/* 1h */
#define CONSOLESTATS_DELAY          600         /* 10 min */
#define AUTO_CACHE_DUMP_DELAY       540         /* 9 min */
#define NETWORK_RECHECK_DELAY       780         /* 13 min */


/* m_glineq */
#define GLINEQ_FULLDEQUE_DELAY      120.0       /* glineq will be send within this delay */
#define GLINEQ_MINDEQUE_INTERVAL    6.0         /* used when there are only a few glines on
                                                 * the gline queue.. (in seconds)
                                                 */


extern Boolean conf_load();
extern void conf_delete();

extern int conf_resolv();
extern Boolean conf_reload();


/* Globals */

struct Me_s *		Me;
struct Uplink_s *	MyUplink;
struct Console_s *	MyConsole;
struct MyClient_s *	MyClient;
struct Perform_s *	MyPerform;
struct Share_s *	MyShare;
struct NoScan_s *	MyNoScan;
struct Log_s *      MyLog;
struct Target_s *   MyTarget;
int totalTarget; /* Added when writing rehash support */
struct Gline_s *    MyGline;


#endif  /* PROXYSCAN_CONF_H */
