#ifndef M_GLINEQ_H
#define M_GLINEQ_H
/* Pxys - An IRC ProxyScan, m_glineq.h
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: m_glineq.h,v 1.2 2001/11/06 22:49:33 mbuna Exp $
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


/* glineq item
 * 12 bytes
 */
struct glineqItem {
   struct glineqItem *   sv;
   struct in_addr        addr;
   unsigned int          type;         /* Type of proxy */
};

typedef struct glineqItem glineqItem;

/* glineq_s, global struct */
struct glineq_s {
   glineqItem *   head;     /* head of chained glines list */
   glineqItem *   last;     /* last item of chained glines list */
   int            size;     /* size of list = number of glines to send */
   struct timeval tv;
};

typedef struct glineq_s glineq_s;


/* Prototypes... */

void glineq_init(), glineq_destroy();
int glineq_push(struct in_addr *addr, unsigned int type);

glineqItem* glineq_pop();
void glineq_popper(struct timeval *tv);


#endif  /* M_GLINEQ_H */
