#ifndef MP_POLL_H
#define MP_POLL_H
/* Pxys - An IRC ProxyScan, mp_poll.h
 * IRC - Internet Relay Chat, ircd/s_bsd.c
 * Copyright (C) 1990 Jarkko Oikarinen and
 *                    University of Oulu, Computing Center
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * poll() macros
 *
 * $Id: mp_poll.h,v 1.1.1.1 2001/10/14 22:09:49 mbuna Exp $
 */


#if defined(POLLMSG) && defined(POLLIN) && defined(POLLRDNORM)
#  define POLLREADFLAGS (POLLMSG|POLLIN|POLLRDNORM)
#else
#  if defined(POLLIN) && defined(POLLRDNORM)
#    define POLLREADFLAGS (POLLIN|POLLRDNORM)
#  else
#    if defined(POLLIN)
#      define POLLREADFLAGS POLLIN
#    else
#      if defined(POLLRDNORM)
#        define POLLREADFLAGS POLLRDNORM
#      endif
#    endif
#  endif
#endif

#if defined(POLLOUT) && defined(POLLWRNORM)
#define POLLWRITEFLAGS (POLLOUT|POLLWRNORM)
#else
#  if defined(POLLOUT)
#    define POLLWRITEFLAGS POLLOUT
#  else
#    if defined(POLLWRNORM)
#      define POLLWRITEFLAGS POLLWRNORM
#    endif
#  endif
#endif

#ifdef POLLHUP
#define POLLERRORS (POLLHUP|POLLERR)
#else
#define POLLERRORS POLLERR
#endif

#ifndef SHUT_RDWR
#define SHUT_RDWR 2
#endif

#define POLL_TIMEOUT 1000 /* 1 sec */

#define DISABLE_PFD(xpfd) \
   do { myclose(xpfd->fd); \
        xpfd->fd = -1; \
        xpfd->events = 0; \
      } while(0)
      
#endif  /* MP_POLL_H */
