/* pxys - An IRC ProxyScan, m_signal.c
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * SIG handlers.
 *
 * $Id: m_signal.c,v 1.3 2001/11/21 15:43:23 mbuna Exp $
 */

#include "config.h"
#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#endif
#include <stdio.h>
#include <stdlib.h>

#include "m_signal.h"
#include "m_array.h"
#include "m_shutdown.h"

#include "ms_globals.h"
#include "ms_msgout.h"
#include "typedefs.h"
#include "conf.h"



extern struct Client *mClient;
extern struct Server *mServer;
int programState_Quitting = 0;
extern pthread_mutex_t mutex_shutdown;
extern int gonnaRehash;

void
sig_term()
{
   pthread_mutex_lock(&mutex_shutdown);
   if(!programState_Quitting) {
     programState_Quitting = 1;
     pthread_mutex_unlock(&mutex_shutdown);
     
     sendto_console("[%s] Received SIGTERM. Aborting.", Me->id) ;
     send_squit("Received SIGTERM") ;
     
     m_shutdown();
     
   }
   exit(EXIT_SUCCESS);
}

void
sig_int()
{
   pthread_mutex_lock(&mutex_shutdown);
   if(!programState_Quitting) {
     programState_Quitting = 1;
     pthread_mutex_unlock(&mutex_shutdown);
     
     sendto_console("[%s] Received SIGINT. Aborting.", Me->id) ;
     send_squit("Received SIGINT") ;
     
     m_shutdown();
     
   }
   exit(EXIT_SUCCESS);
}

void
sig_hup()
{
  
   sendto_console("Received SIGHUP.") ;
   
}

void
sig_usr1()
{
   if(!gonnaRehash) {
      sendto_console("Received SIGUSR1.") ;
      gonnaRehash = 1;
   }
}


void
sig_segv()
{
   pthread_mutex_lock(&mutex_shutdown);
   if(!programState_Quitting) {
     programState_Quitting = 1;
     pthread_mutex_unlock(&mutex_shutdown);
     
     sendto_console("[%s] Received SIGSEGV! Aborting.", Me->id) ;
     send_squit("Received SIGSEGV") ;
     
     m_shutdown();
     
   }
   exit(EXIT_FAILURE);
}


void
sig_pipe()
{
   sendto_console("[%s] Received SIGPIPE! Ignoring.", Me->id) ;
}



/* m_signal.c */
